#include "mcc_generated_files/mcc.h"
#include "font.h"
#include "oled_c.h"

volatile uint8_t bgch = 0x00;
volatile uint8_t bgcl = 0x00;

volatile uint8_t vertical = X_AXIS;
volatile uint8_t v_flip = NOT_FLIPPED;
volatile uint8_t h_flip = NOT_FLIPPED;

void OLED_C_command(unsigned char reg_index, unsigned char reg_value){
//Select index addr
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(reg_index);
    SPI_Exchange8bit(reg_index);
    CS_SetHigh();
//Write data to reg
    CS_SetLow();
    DC_SetHigh();
    //SPI1_Write(reg_value);
    SPI_Exchange8bit(reg_value);
    CS_SetHigh();
}

void OLED_C_data(unsigned char data_value){
    CS_SetLow();
    
    DC_SetHigh();
    //SPI1_Write(data_value);
    SPI_Exchange8bit(data_value);
    CS_SetHigh();
}

void OLED_C_Init(uint8_t orientation){
    
    if (orientation == ORIENTATION_ORIGINAL){
        vertical = Y_AXIS;
        v_flip = NOT_FLIPPED;
        h_flip = NOT_FLIPPED;
    }
    
    if (orientation == ORIENTATION_NORMAL){
        vertical = Y_AXIS;
        v_flip = FLIPPED;
        h_flip = NOT_FLIPPED;
    }
    
    if (orientation == ORIENTATION_DOWN){
        vertical = Y_AXIS;
        v_flip = NOT_FLIPPED;
        h_flip = FLIPPED;
    }
    
    if (orientation == ORIENTATION_LEFT){
        vertical = X_AXIS;
        v_flip = NOT_FLIPPED;
        h_flip = NOT_FLIPPED;
    }
    
    if (orientation == ORIENTATION_RIGHT){
        vertical = X_AXIS;
        v_flip = FLIPPED;
        h_flip = FLIPPED;
    }
    
    RST_SetLow();
    delay_ms(50);
    RST_SetHigh();
    delay_ms(50);
    /*  Soft reset */
    OLED_C_command(SEPS114A_SOFT_RESET,0x00);      
    /* Standby ON/OFF*/
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x01);          // Standby on
    delay_ms(25);                                           // Wait for 5ms (1ms Delay Minimum)
    OLED_C_command(SEPS114A_STANDBY_ON_OFF,0x00);          // Standby off
    delay_ms(25);                                           // 1ms Delay Minimum (1ms Delay Minimum)
    /* Display OFF */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x00);
    /* Set Oscillator operation */
    OLED_C_command(SEPS114A_ANALOG_CONTROL,0x00);          // using external resistor and internal OSC
    /* Set frame rate */
    OLED_C_command(SEPS114A_OSC_ADJUST,0x03);              // frame rate : 95Hz
    /* Set active display area of panel */
    OLED_C_command(SEPS114A_DISPLAY_X1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_X2,0x5F);
    OLED_C_command(SEPS114A_DISPLAY_Y1,0x00);
    OLED_C_command(SEPS114A_DISPLAY_Y2,0x5F);
    /* Select the RGB data format and set the initial state of RGB interface port */
    OLED_C_command(SEPS114A_RGB_IF,0x00);                 // RGB 8bit interface
    /* Set RGB polarity */
    OLED_C_command(SEPS114A_RGB_POL,0x00);
    /* Set display mode control */
    OLED_C_command(SEPS114A_DISPLAY_MODE_CONTROL,0x80);   // SWAP:BGR, Reduce current : Normal, DC[1:0] : Normal
    /* Set MCU Interface */
    OLED_C_command(SEPS114A_CPU_IF,0x00);                 // MPU External interface mode, 8bits
    /* Set Memory Read/Write mode */
    OLED_C_command(SEPS114A_MEMORY_WRITE_READ,0x00);
    /* Set row scan direction */
    OLED_C_command(SEPS114A_ROW_SCAN_DIRECTION,0x00);     // Column : 0 --> Max, Row : 0 --> Max
    /* Set row scan mode */
    OLED_C_command(SEPS114A_ROW_SCAN_MODE,0x00);          // Alternate scan mode
    /* Set column current */
    OLED_C_command(SEPS114A_COLUMN_CURRENT_R,0x6E);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_G,0x4F);
    OLED_C_command(SEPS114A_COLUMN_CURRENT_B,0x77);
    /* Set row overlap */
    OLED_C_command(SEPS114A_ROW_OVERLAP,0x00);            // Band gap only
    /* Set discharge time */
    OLED_C_command(SEPS114A_DISCHARGE_TIME,0x01);         // Discharge time : normal discharge
    /* Set peak pulse delay */
    OLED_C_command(SEPS114A_PEAK_PULSE_DELAY,0x00);
    /* Set peak pulse width */
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_R,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_G,0x02);
    OLED_C_command(SEPS114A_PEAK_PULSE_WIDTH_B,0x02);
    /* Set precharge current */
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_R,0x14);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_G,0x50);
    OLED_C_command(SEPS114A_PRECHARGE_CURRENT_B,0x19);
    /* Set row scan on/off  */
    OLED_C_command(SEPS114A_ROW_SCAN_ON_OFF,0x00);        // Normal row scan
    /* Set scan off level */
    OLED_C_command(SEPS114A_SCAN_OFF_LEVEL,0x04);         // VCC_C*0.75
    /* Set memory access point */
    OLED_C_command(SEPS114A_DISPLAYSTART_X,0x00);
    OLED_C_command(SEPS114A_DISPLAYSTART_Y,0x00);
    /* Display ON */
    OLED_C_command(SEPS114A_DISPLAY_ON_OFF,0x01);
}

void DDRAM_access(){
    CS_SetLow();
    DC_SetLow();
    //SPI1_Write(0x08);
    SPI_Exchange8bit(0x08);
    CS_SetHigh();
}

//Set memory area(address) to write a display data
void OLED_C_MemorySize(point p1, point p2){
    
    if (p1.x > p2.x){
        point pt = p2;
        p2.x = p1.x;
        p1.x = pt.x;
    }
    
    if (p1.y > p2.y){
        point pt = p2;
        p2.y = p1.y;
        p1.y = pt.y;
    }
    
    OLED_C_command(SEPS114A_MEM_X1,p1.x);
    OLED_C_command(SEPS114A_MEM_X2,p2.x);
    OLED_C_command(SEPS114A_MEM_Y1,p1.y);
    OLED_C_command(SEPS114A_MEM_Y2,p2.y);
}

//Select color
void OLED_C_Color(char colorMSB, char colorLSB ){
    OLED_C_data(colorMSB);
    OLED_C_data(colorLSB);
}

void OLED_C_Background(const uint16_t color){
    bgch = color >> 8;
    bgcl = color & 0xFF;
    
    OLED_C_command(0x1D,0x02);                //Set Memory Read/Write mode
    
    point zero;
    zero.x = 0;
    zero.y = 0;
    
    point max;
    max.x = SEPS114A_WIDTH - 1;
    max.y = SEPS114A_HEIGHT - 1;
    
    OLED_C_MemorySize(zero,max);   //Full screen
    DDRAM_access();
    for(unsigned lj=0;lj<9216;lj++){
        OLED_C_Color(bgch,bgcl);
    }
}

uint16_t getBackgroundColor(){
    return bgch << 8 | bgcl;
}

void OLED_C_print_char(point p, const unsigned char ch, const uint16_t color){
    unsigned char chr = 0x00;
    uint8_t chi = color >> 8;
    uint8_t clo = color & 0xFF;
    
    if ((ch < 32) || (ch > 127)){
        chr = ('?' - 32);
    } else {
        chr = (ch - 32);
    }
    
    point p2;
    p2.x = p.x + 4;
    p2.y = p.y + 4;
    
    p = getRealPos(p);
    p2 = getRealPos(p2);
    
    OLED_C_MemorySize(p, p2);
    
    DDRAM_access();
    for(int cx = 0; cx < 5; cx++){
        uint8_t xstep;
        
        
        unsigned char c;
        if (vertical == Y_AXIS){
            if (h_flip == FLIPPED){
               xstep = cx;
            } else {
                xstep = 4 - cx;
            }
            c = Tiny_Font[chr][xstep];
        } else {
            if (h_flip == FLIPPED){
                xstep = cx;
            } else {
                xstep = 4 - cx;
            }
            c = Rotated_Tiny_Font[chr][xstep];
        }
        
        for(int cy = 0; cy < 5; cy ++){
            uint8_t ystep;
            if (vertical == Y_AXIS){
                if (v_flip == FLIPPED){
                    ystep = cy;
                } else {
                    ystep = 4 - cy;
                }
            } else {
                if (v_flip == FLIPPED){
                    ystep = 4 - cy;
                } else {
                    ystep = cy;
                }
            }
            
            if(((c >> ystep) & 0x01) == 0x01){
                OLED_C_Color(chi,clo);
            } else {
                OLED_C_Color(bgch,bgcl);
            }
        }
    }
}


void OLED_C_print(point p, const unsigned char ch[], const uint16_t color){
    point p2;
    for(int cc = 0; cc < length(ch); cc++){
        p2.x = p.x + (cc * 6);
        p2.y = p.y;
        OLED_C_print_char(p2, ch[cc], color);
    }
}

void OLED_C_dot(point p, const uint16_t color){
    uint8_t chi = color >> 8;
    uint8_t clo = color & 0xFF;
    p = getRealPos(p);
    OLED_C_MemorySize(p, p);
    DDRAM_access();
    OLED_C_Color(chi,clo);
}

void OLED_C_rect(point p1, point p2, const uint16_t color){
    uint8_t chi = color >> 8;
    uint8_t clo = color & 0xFF;
    uint8_t dx;
    uint8_t dy;
    
    if (p2.x >= p1.x){
        dx = p2.x - p1.x;
    } else {
        dx = p1.x - p2.x;
    }
    
    if (p2.y >= p1.y){
        dy = p2.y - p1.y;
    } else {
        dy = p1.y - p2.y;
    }
    
    p1 = getRealPos(p1);
    p2 = getRealPos(p2);
    
    OLED_C_MemorySize(p1, p2);
    DDRAM_access();
    for (int i = 0; i < dx; i++){
        for (int j = 0; j < dy; j++){
            OLED_C_Color(chi,clo);
        }
    }
}

point getRealPos(point original){
    point result = original;
    
    if (vertical == X_AXIS){
        result.x = original.y;
        result.y = original.x;
    }
    
    if (v_flip == FLIPPED){
        result.x = SEPS114A_WIDTH - 1 - result.x;
    }
    
    if (h_flip == FLIPPED){
        result.y = SEPS114A_HEIGHT - 1 - result.y;
    }
    
    return result;
}

int length(const unsigned char array[]) {
  int count = 0;
  while(array[count]) count++;
  return count;
}

void delay_ms(int msec){
    TMR1_StartTimer();
    for (int x = 0; x < msec; x++){
        while(!TMR1IF);
        TMR1_Reload();
        TMR1IF = 0;
    }
    //TMR1_StopTimer();
}